#include <stdio.h>
#include <stdlib.h>
#include <io.h>


int EstVal;
int EstDelta;

#define Bit2AdPcm       1
#define Bit3AdPcm       2
#define Bit4AdPcm       3
#define Bit3AdNew       4

 int Next;
 char DataBit,TmpData, TmpCompBit;

 unsigned DestType = Bit4AdPcm;
 char    SbitTbl[6] = { 0x00, 0x02, 0x04, 0x08, 0x04, 0x08 } ;
 int     MaxTbl[8] = { 0x3556, 0x3556, 0x399A, 0x3A9F,\
                       0x4200, 0x4D14, 0x6607, 0x6607 } ;

void InitPredictor() {
 if ( DestType == Bit2AdPcm )    {
         MaxTbl[0] = 0x3800 ;
         MaxTbl[1] = 0x5600 ;
 }
 else if ( DestType == Bit3AdPcm || DestType == Bit3AdNew )  {
         MaxTbl[0] = 0x399A ;
         MaxTbl[1] = 0x3A9F ;
         MaxTbl[2] = 0x4D14 ;
         MaxTbl[3] = 0x6607 ;
 }

 EstVal = 0;
 EstDelta = 5;
}

void UpdatePredictor(int DataBit) {
int     TmpMax ;
char    SignBit ;
long    TmpDelta ;
long    t0 ;


        /* the leakeage */
        t0 = (long)EstVal ;
        t0 *= 4093 ;
        t0 += 2048 ;
        t0 >>= 12; // /= 4096 ;
        EstVal = (int)t0 ;

        SignBit = DataBit & SbitTbl[DestType] ;
        DataBit &= ~SbitTbl[DestType] ;
        if ( (EstDelta&1) && !SignBit )
         ++EstVal;

        /* ------------------- */
        /* Calculate the Delta */
        /* ------------------- */
        TmpDelta = EstDelta;
        TmpDelta *= MaxTbl[DataBit] ;
        TmpDelta += 8192 ;
        TmpDelta >>= 14 ;

        /* -------------------- */
        /* Calculate the EstMax */
        /* -------------------- */
        TmpMax  = (EstDelta>>1) ;
        while ( DataBit-- )
                TmpMax += EstDelta ;
        if ( SignBit )
                EstVal -= TmpMax ;
        else
                EstVal += TmpMax ;

        EstDelta = (int)TmpDelta ;
}


void main(int argc, char **argv) {
 FILE *f1, *f2;

 f1 = fopen(argv[1], "rb");
 if(!f1)
  return;
 f2 = fopen(argv[2], "wb");
 if(!f2)
  return;


 unsigned Code;
 unsigned long uu = 100000l/2;
 InitPredictor();
 while(!feof(f1)) {
  fread(&Code, sizeof(Code), 1, f1);

  UpdatePredictor(Code);
  if (EstVal > 8191 )
          Next = 8191 ;
  else if (EstVal < -8192 )
          Next = -8192 ;
  else
          Next = EstVal;

  if(!(--uu))
   getchar();

  Next <<= 2;
  fwrite(&Next, sizeof(Next), 1, f2);
 }
 fclose(f1);
 fclose(f2);
}
